package config

import (
	"cicv-data-closedloop/pjibot_guide_msgs"
	"github.com/bluenviron/goroslib/v2/pkg/msgs/diagnostic_msgs"
	"github.com/bluenviron/goroslib/v2/pkg/msgs/nav_msgs"
	"github.com/bluenviron/goroslib/v2/pkg/msgs/sensor_msgs"
	"github.com/bluenviron/goroslib/v2/pkg/msgs/std_msgs"
	"sync"
)

var (
	LabelMapTriggerId = new(sync.Map)

	// 1
	TopicOfDiagnostics = "/diagnostics"
	RuleOfDiagnostics  []func(data *diagnostic_msgs.DiagnosticArray) string
	// 2
	TopicOfImu = "/imu"
	RuleOfImu  []func(data *sensor_msgs.Imu) string
	// 3
	TopicOfLocateInfo = "/locate_info"
	RuleOfLocateInfo  []func(data *pjibot_guide_msgs.LocateInfo) string
	// 4
	TopicOfObstacleDetection = "/obstacle_detection"
	RuleOfObstacleDetection  []func(data *std_msgs.UInt8) string
	// 5
	TopicOfOdom = "/odom"
	RuleOfOdom  []func(data *nav_msgs.Odometry) string
	// 6
	TopicOfSysInfo = "/sys_info"
	RuleOfSysInfo  []func(data *pjibot_guide_msgs.SysInfo) string
	// todo 这里是全量的topic，添加topic则需要同时在下面的数组添加；也需要在produce_window.go中添加新的订阅者
	AllTopics = []string{
		TopicOfDiagnostics,       // 1
		TopicOfImu,               // 2
		TopicOfLocateInfo,        // 3
		TopicOfObstacleDetection, // 4
		TopicOfOdom,              // 5
		TopicOfSysInfo,           // 6
	}
	AllTopicsNumber = len(AllTopics)
)
