package config

import (
	"cicv-data-closedloop/pjibot_patrol_msgs"
	"github.com/bluenviron/goroslib/v2/pkg/msgs/diagnostic_msgs"
	"github.com/bluenviron/goroslib/v2/pkg/msgs/geometry_msgs"
	"github.com/bluenviron/goroslib/v2/pkg/msgs/nav_msgs"
	"github.com/bluenviron/goroslib/v2/pkg/msgs/sensor_msgs"
	"github.com/bluenviron/goroslib/v2/pkg/msgs/std_msgs"
	"sync"
)

var (
	LabelMapTriggerId = new(sync.Map)
	// 1
	TopicOfDiagnostics = "/diagnostics"
	RuleOfDiagnostics  []func(data *diagnostic_msgs.DiagnosticArray) string
	// 2
	TopicOfImu = "/imu"
	RuleOfImu  []func(data *sensor_msgs.Imu) string
	// 3
	TopicOfLocateInfo = "/locate_info"
	RuleOfLocateInfo  []func(data *pjibot_patrol_msgs.LocateInfo) string
	// 4
	TopicOfObstacleDetection = "/obstacle_detection"
	RuleOfObstacleDetection  []func(data *std_msgs.UInt8) string
	// 5
	TopicOfOdom = "/odom"
	RuleOfOdom  []func(data *nav_msgs.Odometry) string
	// 6
	TopicOfSysInfo = "/sys_info"
	RuleOfSysInfo  []func(data *pjibot_patrol_msgs.SysInfo) string
	// 7
	TopicOfRobotPose = "/robot_pose"
	RuleOfRobotPose  []func(data *geometry_msgs.PoseStamped) string
	// 8
	TopicOfTaskFeedbackInfo = "/task_feedback_info"
	RuleOfTaskFeedbackInfo  []func(data *pjibot_patrol_msgs.TaskFeedbackInfo) string
	// 9
	TopicOfWheelOdom = "/wheel_odom"
	RuleOfWheelOdom  []func(data *nav_msgs.Odometry) string

	// todo 这里是全量的topic，添加topic则需要同时在下面的数组添加；也需要在produce_window.go中添加新的订阅者
	AllTopics = []string{
		TopicOfDiagnostics,       // 1
		TopicOfImu,               // 2
		TopicOfLocateInfo,        // 3
		TopicOfObstacleDetection, // 4
		TopicOfOdom,              // 5
		TopicOfSysInfo,           // 6
		TopicOfRobotPose,         // 7
		TopicOfTaskFeedbackInfo,  // 8
		TopicOfWheelOdom,         // 9
	}
	AllTopicsNumber = len(AllTopics)
)
