package main

import (
	"cicv-data-closedloop/amd64/web_server/src/infrastructure/config"
	"cicv-data-closedloop/amd64/web_server/src/infrastructure/http"
	"cicv-data-closedloop/common/config/c_db"
	"cicv-data-closedloop/common/config/c_log"
	_ "embed"
	_ "gopkg.in/yaml.v3"
)

func init() {
	config.InitApplication()
	c_log.InitLog(
		config.ApplicationYaml.Log.Dir,
		config.ApplicationYaml.Log.Prefix,
	)
	c_db.InitSqlxMysql(
		config.ApplicationYaml.Mysql.Username,
		config.ApplicationYaml.Mysql.Password,
		config.ApplicationYaml.Mysql.Ip,
		config.ApplicationYaml.Mysql.Port,
		config.ApplicationYaml.Mysql.Dbname,
		config.ApplicationYaml.Mysql.Charset,
	)
	c_db.InitSqlFilesMap(config.ApplicationYaml.Mysql.SqlfileDir)
}

func main() {
	c_log.GlobalLogger.Info("配置文件为：", config.ApplicationYaml)
	go http.CreateServer()
	select {}
}
