package test

import (
	"cicv-data-closedloop/pjisuv_msgs"
	"github.com/bluenviron/goroslib/v2"
	"log"
	"testing"
)

func TestGoroslibSubscriber(t *testing.T) {
	// create a node and connect to the master
	n, err := goroslib.NewNode(goroslib.NodeConf{
		Name:          "goroslib_sub",
		MasterAddress: "127.0.0.1:11311",
	})
	if err != nil {
		panic(err)
	}
	defer n.Close()

	// create a subscriber
	sub, err := goroslib.NewSubscriber(goroslib.SubscriberConf{
		Node:  n,
		Topic: "/cicv_location",
		Callback: func(msg *pjisuv_msgs.PerceptionLocalization) {
			log.Printf("Incoming: %+v\n", msg)
		},
	})
	if err != nil {
		panic(err)
	}
	defer sub.Close()

}
