package main

import (
	"fmt"
	"github.com/bluenviron/goroslib/v2/pkg/msgs/nav_msgs"
	"math"
	"time"
)

func Topic() string {
	return "/wheel_odom"
}

func Label() string {
	return "AuLongStop"
}

var (
	StartTime int64
	IsStopped bool
)

func Rule(data *nav_msgs.Odometry) string {
	velocityX := data.Twist.Twist.Linear.X
	velocityY := data.Twist.Twist.Linear.Y
	absV := math.Pow(math.Pow(velocityX, 2)+math.Pow(velocityY, 2), 0.5)
	if absV < 0.3 {
		// 如果之前没有记录开始时间，记录当前时间
		if StartTime == 0 {
			StartTime = time.Now().Unix()
		}

		// 判断是否持续超过一分钟
		if time.Now().Unix()-StartTime > 10 {
			if !IsStopped {
				event_label := "AuLongStop"
				fmt.Println(event_label)
				IsStopped = true
				return Label()
			}
		}
	} else {
		// 如果速度大于 0.1，重置开始时间和停止标志
		StartTime = 0
		//is_stopped = false
	}
	return ""

}
