package main

import (
	"fmt"

	"github.com/bluenviron/goroslib/v2/pkg/msgs/std_msgs"
)

func Topic() string {
	return "/obstacle_detection"
}

func Label() string {
	return "obstacledetection"
}

func Rule(data *std_msgs.UInt8) string {
	/*
		0-表示导航前方无障碍物，
		1-表示找不到全局路径
		2-表示前方有障碍物但能绕过去
		3-表示前方有障碍物且局部规划不过去
	*/
	switch data.Data {
	case 0:
		fmt.Println("无法避障触发器的当前状态为 0，表示导航前方无障碍物")
	case 1:
		fmt.Println("无法避障触发器的当前状态为 1，表示找不到全局路径")
	case 2:
		fmt.Println("无法避障触发器的当前状态为 2，表示前方有障碍物但能绕过去")
	case 3:
		fmt.Println("无法避障触发器的当前状态为 3，表示前方有障碍物且局部规划不过去")
		return "obstacledetection"
	}
	return ""
}
