package main

import (
	"cicv-data-closedloop/pjisuv_msgs"
	"fmt"
	"math"
	"sync"
)

func Topic() string {
	return "/cicv_location"
}

// todo 禁止存在下划线_
func Label() string {
	return "FindTrafficLight"
}

type Point struct {
	Latitude  float64
	Longitude float64
}

var (
	count1 int = 0

	//定义园区４个信号灯的坐标
	//point = Point{39.72975930689718, 116.48861102824081}
	//point3 = Point{39.7288805296616, 116.48812315228867}
	point = Point{39.73061430369551, 116.49225103553502}
	//point5 = Point{39.73077491578002, 116.49060085035634}

	//pointlist = []Point{point2, point3, point4, point5}
)

func Rule(shareVars *sync.Map, data *pjisuv_msgs.PerceptionLocalization) string {
	defer func() {
		if r := recover(); r != nil {
			fmt.Println("Recovered from panic:", r)
		}
	}()
	if count1%10 == 0 {

		enterflag := IfEnter(point, 25.0, data.Latitude, data.Longitude)
		AbsSpeed, _ := shareVars.Load("AbsSpeed")
		if enterflag && AbsSpeed.(float64) > 1 {
			//eventLabel := "FindTrafficLight"
			//fmt.Println(eventLabel)
			return "FindTrafficLightP1"
		}
	}
	count1++
	return ""
}

func IfEnter(point Point, radius float64, lat, lon float64) bool {
	// 判断是否进入点列表中的区域
	point1 := Point{Latitude: lat, Longitude: lon}
	d := distance(point1, point)
	if d <= radius {
		return true
	}

	return false
}

// 计算两点之间的距离（米）
func distance(point1, point2 Point) float64 {
	// 经纬度转弧度
	lat1 := point1.Latitude * math.Pi / 180
	lon1 := point1.Longitude * math.Pi / 180
	lat2 := point2.Latitude * math.Pi / 180
	lon2 := point2.Longitude * math.Pi / 180

	// 计算距离
	dlon := lon2 - lon1
	dlat := lat2 - lat1
	a := math.Sin(dlat/2)*math.Sin(dlat/2) + math.Sin(dlon/2)*math.Sin(dlon/2)*math.Cos(lat1)*math.Cos(lat2)
	c := 2 * math.Atan2(math.Sqrt(a), math.Sqrt(1-a))
	d := 6371000 * c
	return d
}
