package main

import (
	"cicv-data-closedloop/pjisuv_msgs"
	"fmt"
	"math"
	"sync"
	"time"
)

var (
	StartTime int64
	count1    int64
)

func Topic() string {
	return "/cicv_location"
}

// 禁止存在下划线_
func Label() string {
	return "RearVehicleFollowingTooCloseLow"
}

func IfObstaclesNearby(shareVars *sync.Map) bool {
	ObjDicOfTpperception, ok1 := shareVars.Load("objDicOfTpperception")
	ObjDic := ObjDicOfTpperception.(map[uint32][][]float32)
	if ok1 {
		for _, obj := range ObjDic {
			if obj[0][len(obj[0])-1] >= -12 && obj[0][len(obj[0])-1] <= -1 && (math.Abs(float64(obj[1][len(obj[1])-1]))) <= 2.0 {
				return true

			}
		}
	}
	return false
}
func Rule(shareVars *sync.Map, data *pjisuv_msgs.PerceptionLocalization) string {
	defer func() {
		if r := recover(); r != nil {
			fmt.Println("Recovered from panic:", r)
		}
	}()
	if count1%20 == 0 {
		OutsideWorkshopFlag, _ := shareVars.Load("OutsideWorkshopFlag")
		OutsideWorkshopFlag = OutsideWorkshopFlag.(bool)
		if OutsideWorkshopFlag == true {
			AbsSpeed, _ := shareVars.Load("AbsSpeed")
			flag := IfObstaclesNearby(shareVars)
			if AbsSpeed.(float64) >= 1 && AbsSpeed.(float64) <= 3 && flag {
				// 如果之前没有记录开始时间，记录当前时间
				if StartTime == 0 {
					StartTime = time.Now().Unix()
				}
				// 判断是否持续超过 50s
				if time.Now().Unix()-StartTime > 3 {
					count1 = 1
					return Label()
				}
			} else {
				// 如果速度大于 0.1，重置开始时间和停止标志
				StartTime = 0

			}
		} else {
			StartTime = 0
		}
	}
	count1++
	return ""
}
