package main

import (
	"cicv-data-closedloop/pjisuv_ticker"
	"fmt"
	"sync"
	"time"
)

var ()

// 定时任务触发器固定的
func Topic() string {
	return pjisuv_ticker.TickerTopic
}

// ******* 禁止存在下划线_
// 触发器标记
func Label() string {
	return "CCCscpo"
}

func Rule(shareVars *sync.Map) {
	defer func() {
		if r := recover(); r != nil {
			fmt.Println("Recovered from panic:", r)
		}
	}()
	// 1 使用goroutine
	go func(shareVars *sync.Map) {
		// 2 定义触发器的间隔时间
		ticker := time.NewTicker(time.Duration(3) * time.Second)
		defer ticker.Stop()
		// 3 运行一个无限循环
		for {
			select {
			// 定时器触发时执行的代码
			case <-ticker.C:
				FinalCallback(shareVars)

			}
		}
	}(shareVars)
}
func findIndex(lst []float32, target float32) int {
	for i, v := range lst {
		if v == target {
			return i
		}
	}
	return -1
}

func isCrossAndOcclusion(id uint32, ObjectList [][]float32, ObjectSlice map[uint32][][]float32, AbsSpeed float64) bool {
	for i := 0; i < len(ObjectList[0]); i++ {
		xi := ObjectList[0][i]
		yi := ObjectList[1][i]
		diff_hi := ObjectList[7][i]
		Type := ObjectList[6][0]

		if xi >= 0 && yi <= -3 && diff_hi <= 120 && diff_hi >= 60 && Type != 1.0 && AbsSpeed > 1 {
			startFrame1 := ObjectList[5][i]

			for j := 0; j < len(ObjectList[0])-i-1; j++ {
				xj := ObjectList[0][j]
				yj := ObjectList[1][j]
				diff_hj := ObjectList[7][j]
				if xj >= 0 && yj >= 1 && diff_hj <= 120 && diff_hj >= 60 {
					startFrame2 := ObjectList[5][j]
					for this_id, objValue := range ObjectSlice {
						if this_id != id {

							this_startFrame_index1 := findIndex(objValue[5], startFrame1)
							this_startFrame_index2 := findIndex(objValue[5], startFrame2)
							this_type := objValue[6][0]
							//fmt.Println(objValue[0][this_startFrame_index2], xj)

							if objValue[0][this_startFrame_index1] >= 2 && objValue[0][this_startFrame_index1] < xi-1 && objValue[1][this_startFrame_index1] < 0 && objValue[1][this_startFrame_index1] > yi && objValue[0][this_startFrame_index2] >= 1 && objValue[0][this_startFrame_index2] < xj-1 && objValue[1][this_startFrame_index2] < 0 && (this_type == 2.0 || this_type == 3.0) {
								return true
							}
						} else {
							continue
						}
					}
				}
			}
		}
	}
	return false
}
func FinalCallback(shareVars *sync.Map) {

	OutsideWorkshopFlag, ok := shareVars.Load("OutsideWorkshopFlag")
	ObjDicOfTpperception, ok1 := shareVars.Load("objDicOfTpperception")
	ObjDic := ObjDicOfTpperception.(map[uint32][][]float32)
	AbsSpeed, ok2 := shareVars.Load("AbsSpeed")

	if ok && ok1 && ok2 && OutsideWorkshopFlag.(bool) == true {
		for id, objValue := range ObjDic {
			if len(ObjDic[0]) <= 10 || !isCrossAndOcclusion(id, objValue, ObjDic, AbsSpeed.(float64)) {
				continue
			}
			event_lable := "CCCscpo"
			fmt.Println(event_lable)
			pjisuv_ticker.TickerChan <- pjisuv_ticker.TickInfo{FaultLabel: Label(), FaultHappenTime: pjisuv_ticker.GetNowTimeCustom()}
		}

	}

}
