package main

import (
	"cicv-data-closedloop/pjisuv_ticker"
	"fmt"
	"sync"
	"time"
)

// 定时任务触发器固定的
func Topic() string {
	return pjisuv_ticker.TickerTopic
}

// ******* 禁止存在下划线_
// 触发器标记
func Label() string {
	return "FrontCarSideBySide"
}

func Rule(shareVars *sync.Map) {
	defer func() {
		if r := recover(); r != nil {
			fmt.Println("Recovered from panic:", r)
		}
	}()
	// 1 使用goroutine
	go func(shareVars *sync.Map) {
		// 2 定义触发器的间隔时间
		ticker := time.NewTicker(time.Duration(3) * time.Second)
		defer ticker.Stop()
		// 3 运行一个无限循环
		for {
			select {
			// 定时器触发时执行的代码
			case <-ticker.C:
				FinalCallback(shareVars)

			}
		}
	}(shareVars)
}

func FinalCallback(shareVars *sync.Map) {
	countSideBySide, ok := shareVars.Load("CountSideBySide")
	if ok {
		if countSideBySide.(int) >= 20 {
			event_lable := "FrontCarSideBySide"
			fmt.Println(event_lable)
			pjisuv_ticker.TickerChan <- pjisuv_ticker.TickInfo{FaultLabel: Label(), FaultHappenTime: pjisuv_ticker.GetNowTimeCustom()}

		}

	}
	shareVars.Store("countSideBySide", 0)
}
