package main

import (
	"cicv-data-closedloop/pjisuv_ticker"
	"fmt"
	"math"
	"sync"
	"time"
)

type Point struct {
	Latitude  float64
	Longitude float64
}

var (
	Maxlenobj int32 = 0
	//定义园区Ｔ字路口的经纬度坐标值
)

// 定时任务触发器固定的
func Topic() string {
	return pjisuv_ticker.TickerTopic
}

// ******* 禁止存在下划线_
// 触发器标记
func Label() string {
	return "FrontVehicleBrakeInJunction"
}

func Rule(shareVars *sync.Map) {
	defer func() {
		if r := recover(); r != nil {
			fmt.Println("Recovered from panic:", r)
		}
	}()
	// 1 使用goroutine

	go func(shareVars *sync.Map) {
		// 2 定义触发器的间隔时间
		ticker := time.NewTicker(time.Duration(3) * time.Second)
		defer ticker.Stop()
		// 3 运行一个无限循环
		for {
			select {
			// 定时器触发时执行的代码
			case <-ticker.C:
				FinalCallback(shareVars)

			}
		}
	}(shareVars)
}
func isBrake(ObjectList [][]float32) bool {
	for i, speed := range ObjectList[3] {

		if math.Abs(float64(ObjectList[1][i])) <= 5.3 && speed >= 6/3.6 && ObjectList[0][i] >= 1.3 {
			for j := 0; j < len(ObjectList[0])-i-1; j++ {
				if math.Abs(float64(ObjectList[1][1+i+j])) <= 5.3 && ObjectList[3][1+i+j] <= 1/3.6 {
					return true
				}
			}
		}
	}
	return false
}

func FinalCallback(shareVars *sync.Map) {
	OutsideWorkshopFlag, ok := shareVars.Load("OutsideWorkshopFlag")
	ObjDicOfTpperception, ok1 := shareVars.Load("objDicOfTpperception")
	ObjDic := ObjDicOfTpperception.(map[uint32][][]float32)
	EnterJunctionFlag, ok4 := shareVars.Load("EnterJunctionFlag")

	if ok && ok1 && ok4 && OutsideWorkshopFlag.(bool) == true {
		enterflag := EnterJunctionFlag.(bool)
		if enterflag {
			for _, objValue := range ObjDic {
				Maxlenobj = max(Maxlenobj, int32(len(objValue[0])))
				if len(ObjDic[0]) <= 10 || !isBrake(objValue) {
					continue
				}
				event_lable := "FrontVehicleBrakeInJunction"
				fmt.Println(event_lable)
				//ObjDicOfTpperception = make(map[uint32][][]float32)
				pjisuv_ticker.TickerChan <- pjisuv_ticker.TickInfo{FaultLabel: Label(), FaultHappenTime: pjisuv_ticker.GetNowTimeCustom()}
			}
		}
		if Maxlenobj >= 100 {
			ObjDicOfTpperception = make(map[uint32][][]float32)
			shareVars.Store("ObjDicOfTpperception", ObjDicOfTpperception)
			Maxlenobj = 0
		}
	}

}
