package main

import (
	"cicv-data-closedloop/pjisuv_ticker"
	"fmt"
	"math"
	"sync"
	"time"
)

var (
	Maxlenobj int32 = 0
)

// 定时任务触发器固定的
func Topic() string {
	return pjisuv_ticker.TickerTopic
}

// ******* 禁止存在下划线_
// 触发器标记
func Label() string {
	return "LongTimeParallel"
}

func Rule(shareVars *sync.Map) {
	defer func() {
		if r := recover(); r != nil {
			fmt.Println("Recovered from panic:", r)
		}
	}()
	// 1 使用goroutine
	go func(shareVars *sync.Map) {
		// 2 定义触发器的间隔时间
		ticker := time.NewTicker(time.Duration(2) * time.Second)
		defer ticker.Stop()
		// 3 运行一个无限循环
		for {
			select {
			// 定时器触发时执行的代码
			case <-ticker.C:
				FinalCallback(shareVars)

			}
		}
	}(shareVars)
}
func getMaxValue(slice []int) int {
	max := slice[0]
	for _, value := range slice {
		if value > max {
			max = value
		}
	}
	return max
}
func isParallel(ObjectList [][]float32) bool {
	numParallelslice := []int{0}
	numParallel := 0
lable1:
	for i := 0; i < len(ObjectList[1]); i++ {
		objx := ObjectList[0][i]
		objy := ObjectList[1][i]
		if math.Abs(float64(objx)) <= 2 && math.Abs(float64(objy)) <= 4.5 {
			for j := 0; j < len(ObjectList[1])-i-1; j++ {
				objxj := ObjectList[0][1+i+j]
				objyj := ObjectList[1][1+i+j]
				if math.Abs(float64(objxj)) <= 2 && math.Abs(float64(objyj)) <= 4.5 {
					numParallel++
				} else {
					i = i + j + 1
					numParallelslice = append(numParallelslice, numParallel)
					numParallel = 0
					continue lable1
				}
			}
			numParallelslice = append(numParallelslice, numParallel)
			break lable1
		} else {
			i++
		}
	}
	maxValue := getMaxValue(numParallelslice)
	fmt.Println(maxValue)
	if maxValue >= 100 {
		return true
	} else {
		return false
	}
}
func FinalCallback(shareVars *sync.Map) {
	OutsideWorkshopFlag, ok := shareVars.Load("OutsideWorkshopFlag")
	ObjDicOfTpperception, ok1 := shareVars.Load("objDicOfTpperception")
	ObjDic := ObjDicOfTpperception.(map[uint32][][]float32)
	AbsSpeed, _ := shareVars.Load("AbsSpeed")

	if ok && ok1 && OutsideWorkshopFlag.(bool) == true {
		for _, objValue := range ObjDic {
			Maxlenobj = max(Maxlenobj, int32(len(objValue[0])))
			if len(ObjDic[0]) <= 10 || !isParallel(objValue) && AbsSpeed.(float64) >= 1 {
				continue
			}
			event_lable := "LongTimeParallel"
			fmt.Println(event_lable)
			pjisuv_ticker.TickerChan <- pjisuv_ticker.TickInfo{FaultLabel: Label(), FaultHappenTime: pjisuv_ticker.GetNowTimeCustom()}
		}

		if Maxlenobj >= 100 {
			ObjDicOfTpperception = make(map[uint32][][]float32)
			shareVars.Store("ObjDicOfTpperception", ObjDicOfTpperception)
			Maxlenobj = 0
		}
	}

}
