package main

import (
	"cicv-data-closedloop/pjisuv_msgs"
	"fmt"
	"math"
	"sync"
)

func Topic() string {
	return "/tpperception"
}

// 禁止存在下划线_
func Label() string {
	return "CPTAn"
}

func Rule(shareVars *sync.Map, data *pjisuv_msgs.PerceptionObjects) string {
	defer func() {
		if r := recover(); r != nil {
			fmt.Println("Recovered from panic:", r)
		}
	}()
	OutsideWorkshopFlag, ok3 := shareVars.Load("OutsideWorkshopFlag")
	PositionXOfCicvLocation, ok2 := shareVars.Load("PositionXOfCicvLocation")
	PositionYOfCicvLocation, ok1 := shareVars.Load("PositionYOfCicvLocation")
	RightCurveFlag, ok := shareVars.Load("RightCurveFlag")

	if ok && ok1 && ok2 && ok3 && OutsideWorkshopFlag.(bool) && RightCurveFlag.(bool) == true {

		for _, obj := range data.Objs {
			if obj.Type == 1 {
				Distance := math.Sqrt(math.Pow(PositionXOfCicvLocation.(float64)-obj.Xabs, 2) + math.Pow(PositionYOfCicvLocation.(float64)-obj.Yabs, 2))
				Objspeed := math.Sqrt(math.Pow(float64(obj.Vxabs), 2) + math.Pow(float64(obj.Vyabs), 2))
				//fmt.Println("Distance:", Distance)
				if obj.X >= 2.0 && obj.X <= 30.0 && Distance <= 20.0 && Objspeed > 0.7 {
					event_lable := "CPTA_n"
					fmt.Println(event_lable)
					return Label()
				}
			}
		}
	}

	return ""
}
