package main

import (
	"cicv-data-closedloop/pjisuv_msgs"
	"fmt"
	"sync"
)

/*
   if obj_type_dic is not {}: #相邻两帧对于同一目标物感知类型不一致
       if obj.id in obj_type_dic:
           if obj.type != obj_type_dic[obj.id]:
               event_label='perceptiontypediffer'

               print(event_label)
           else:
               print(obj.type,"   ",obj_type_dic[obj.id])
*/

func Topic() string {
	return "/tpperception"
}

// 禁止存在下划线_
func Label() string {
	return "PerceptionTypeDiffer"
}

func Rule(shareVars *sync.Map, data *pjisuv_msgs.PerceptionObjects) string {
	defer func() {
		if r := recover(); r != nil {
			fmt.Println("Recovered from panic:", r)
		}
	}()
	value, ok := shareVars.Load("ObjTypeDicOfTpperception")
	if ok {
		objTypeDicOfTpperception := value.(map[uint32]uint8)
		for _, obj := range data.Objs {
			if len(objTypeDicOfTpperception) != 0 {
				for _, lastObjType := range objTypeDicOfTpperception {
					if lastObjType != obj.Type {
						return Label()
					}
				}
			}
		}
	}

	return ""
}
